<?php

function quiz_body_creater($atts){
	global $wpdb;
	$wpdb->show_errors(); 
	
	ob_start();
	$attr_id = intval($atts["id"]);
	
	if($attr_id<1) {
		echo "<h2>".__("Quiz is not selected! Please, read readme.txt", 'ssquiz')."</h2>";
		$output_string=ob_get_contents();
		ob_end_clean();
		return $output_string;
	}

	$session=rand();
	$quiz_title = $wpdb->get_var("SELECT title FROM ssquiz_quizzes WHERE id=$attr_id");
	$quiz_description = $wpdb->get_var("SELECT description FROM ssquiz_quizzes WHERE id=$attr_id");
	$quiz_next = $wpdb->get_var("SELECT next FROM ssquiz_quizzes WHERE id=$attr_id");
	$total = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_questions WHERE quiz_id=$attr_id AND number!=99999");
	if(in_array("not_correct", $atts)) set_transient('not_correct_answers'.$session, 'true', 9999);

	//alex
	//if(in_array("show_correct", $atts)) 
		set_transient('show_correct'.$session, 'true', 9999);
	
	if(in_array("all", $atts)) set_transient('all_questions'.$session, 'true', 9999);
	if(in_array("qrandom", $atts)) set_transient('qrandom'.$session, 'true', 9999);
	if(in_array("arandom", $atts)) set_transient('arandom'.$session, 'true', 9999);
	if(in_array("email", $atts)) set_transient('email'.$session, 'true', 9999);
	if(in_array("name", $atts)) set_transient('name'.$session, 'true', 9999);
	if($atts["timer"]>0) set_transient('timer'.$session, 'true', 9999);
	set_transient('quiz_id'.$session, $atts["id"], 9999);
	set_transient('quiz_title'.$session, $quiz_title, 9999);
	set_transient('quiz_description'.$session, $quiz_description, 9999);
	set_transient('quiz_next'.$session, $quiz_next, 9999);
	set_transient('questions_counter'.$session, -1, 9999);
	set_transient('questions_right'.$session, 0, 9999);
	set_transient('total_questions'.$session, $total, 9999);
	set_transient('answer_sheet'.$session, array());
	
	$welcome = $wpdb->get_var("SELECT value FROM ssquiz_settings WHERE name='start_screen'");
	$welcome = str_replace("%%TITLE%%", $quiz_title, $welcome);
	$welcome = str_replace("%%DESCRIPTION%%", $quiz_description, $welcome);
	$welcome = str_replace("%%QUESTIONS%%", $total, $welcome);
	?>
    <div class="quiz" id="<?php echo $session;?>">
		<div class="ssquiz_header">
			<div>
				<h2 align='center'><?php echo $quiz_title; ?></h2>
			</div>
			<?php 
			if(get_transient("timer".$session)) {
				echo '<script>seconds_left='.$atts['timer'].';</script>';
				echo '<div id="timer_icon"></div><div class="sstimer"><span>'.__("Time left", 'ssquiz').': </span><span id="sstimer"></span></div>';
			}
			?>
		</div> <!-- end of ssquiz_header -->
		
		<?php
		// does user have chance to take this quiz?
		if(in_array("one_chance", $atts)) {
			global $current_user;
			get_currentuserinfo();
			$attempts = $wpdb->get_var( "SELECT count(*) FROM ssquiz_users WHERE user_name='".$current_user->user_login."' AND quiz='".$quiz_title."'");
			if($attempts>0){
				echo "<h2 align='center'>".__("You already took this quiz", 'ssquiz')."</h2>";
				echo '</div>';
				$output_string=ob_get_contents();
				ob_end_clean();
				return $output_string;
			}
		}
		?>
		
		<div class="quiz_area">
			<?php echo stripslashes(html_entity_decode($welcome)); ?>
			<?php echo stripslashes(html_entity_decode($myrows)) ?>
			<br />
			<br />
			<?php 
			if(get_transient("name".$session)) {
				echo '<label for="user_name">'.__("Name", 'ssquiz').': </label>';
				echo '<input type="text" id="ssuser_name" name="user_name" value="" />';
				echo '<br />';
			}
			if(get_transient("email".$session)) {
				echo '<label for="email">'.__("E-Mail", 'ssquiz').': </label> ';
				echo '<input type="text"  id="ssemail" name="email" value="" />';
			} ?>
		</div> <!-- end of quiz_area -->
		
		<div class="sshistory"></div>
		
		<a href="#ssheader" class="start user_button" id="next_button"><?php echo __("Start", 'ssquiz') ?></a>
		<br  />
		<a href="#" class="exit_but user_button" id="exit_but" style="display:none"><?php echo __("Exit", 'ssquiz') ?></a>
    </div>
 	<?php
	
	$output_string=ob_get_contents();
	ob_end_clean();
	return $output_string;
}

function tag_replace($result, $session, $file_name='') {
	$temp_var=intval(get_transient('total_questions'.$session));
	if($temp_var==0) $temp_var=-1;
	$percent=intval(strval(100*intval(get_transient('questions_right'.$session))/$temp_var));
	
	$result=str_replace("%%TITLE%%", get_transient('quiz_title'.$session), $result);
	$result=str_replace("%%DESCRIPTION%%", get_transient('quiz_description'.$session), $result);
	$result=str_replace("%%TOTAL%%", get_transient('total_questions'.$session), $result);
	$result=str_replace("%%CORRECT%%", get_transient('questions_right'.$session), $result);
	$result=str_replace("%%PERCENT%%", $percent, $result);
	$result=str_replace("%%DATE%%", date('l jS F Y'), $result);
	$dir = wp_upload_dir();
	$dir = $dir["baseurl"] . "/exams/";
	$url = $dir . $file_name . ".pdf";
	$result=str_replace("%%FILE%%", $url, $result);
	
	return $result;
}

function exit_quiz($session=0, $button_clicked=false){
		global $wpdb;
		$wpdb->show_errors(); 
		if(isset($_POST["session"]))
			$session=intval($_POST["session"]);
		$result = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='result_screen' LIMIT 1");
		echo '<script>document.getElementById("next_button").style.display="none";document.getElementById("exit_but").style.display="none";clearTimeout(timer1); </script>';
		if(isset($_POST['question_id']) && $button_clicked){
			next_question(true);
		}

		if(get_transient('not_correct_answers'.$session)==false){
			$answer_sheet=get_transient('answer_sheet'.$session);
			//echo '</br>';
			echo '<div class="sshistory_list">';
			foreach($answer_sheet as $name=>$value) {
				if($value["correct"])
					echo '<a href="#" class="ssanswer_history sshistory_number" style="color:green" id="'.$value["question_id"].'">'.$name.'</a> ';
				else
					echo '<a href="#" class="ssanswer_history sshistory_number" style="color:red" id="'.$value["question_id"].'">'.$name.'</a> ';
			}
			echo '</div>';
			//echo '</div>';
		}

		// create no report when aborting
		if(!$button_clicked)
			die();

		global $current_user;
		get_currentuserinfo();
		
		if(get_transient("name".$session))
			$users_name = get_transient("user_name".$session);
		else if(strlen($current_user->display_name)>3)
			$users_name = $current_user->display_name;
		else
			$users_name = "UNKNOWN";

		$result=str_replace("%%NAME%%", $users_name, $result);
		$result=str_replace("%%NUMBER%%", get_transient('quiz_id'.$session), $result);
		$result=stripslashes(html_entity_decode(tag_replace($result, $session)));
		if(get_transient("essay".$session))
			$result = "Your exam has been submitted for review.  Please consult with your instructor for your results.";
		
		$result .= '<div style="text-align:center;">';
		//was wrong?
		if(get_transient('questions_right'.$session) != get_transient('total_questions'.$session))
			$result .= '<form method="post" onsubmit="history.go(0)()" style="display:inline"><input style="display:block; margin: 20px 20px; display:inline" type=submit value="Dare to go again?"/></form>';
			
		//next exam?
		if(get_transient("quiz_next".$session)>"")
			$result .= '<form action="'.get_transient("quiz_next".$session).'" method="post" onsubmit="go()" style="display:inline"><input style="display:block; margin: 20px auto; display:inline" type=submit value="Next Exam"/></form>';
		$result .= '</div>';

		echo $result;

		if(get_transient("email".$session))
			$users_email = get_transient("user_email".$session);
		else if(strlen($current_user->user_email)>5)
			$users_email = $current_user->user_email;
		else
			$users_email = "UNKNOWN";

		// API
		$temp_var=intval(get_transient('total_questions'.$session));
		if($temp_var==0) $temp_var=-1;
		$percent=intval(strval(100*intval(get_transient('questions_right'.$session))/$temp_var));
		do_action( 'ssquiz_finished', get_transient('quiz_id'.$session), $percent, get_transient('questions_right'.$session), get_transient('total_questions'.$session));
		
		//create pdf
		$file_name = $users_name.date("mdy_Gis");
		//create_pdf($session, $file_name);

		//Sending email to user
		$test_query = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='user_recieve'");
		if($test_query=='checked') {
			if($users_email != "UNKNOWN") {
				$email = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='email_screen' LIMIT 1");
				$message = stripslashes(html_entity_decode(tag_replace($email, $session, $file_name)));
				$header = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='users_header' LIMIT 1");
				$header = str_replace("%%NAME%%", $users_name, $header);
				$header=str_replace("%%TITLE%%", get_transient('quiz_title'.$session), $header);
				wp_mail($users_email, $header, $message);
			}
		}

		//Sending email to teacher
		$test_query = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='should_recieve'");
		if($test_query=='checked') {
			$teachers_email = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='ssteachers_email'");
			if(strlen($teachers_email)>5) {
				$email = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='ssteachers_template' LIMIT 1");
				$message = stripslashes(html_entity_decode(tag_replace($email, $session, $file_name)));
				$message=str_replace("%%NAME%%", $users_name, $message);
				$message=str_replace("%%EMAIL%%", $users_email, $message);
				$header = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='teachers_header' LIMIT 1");
				$header = str_replace("%%NAME%%", $users_name, $header);
				$header=str_replace("%%TITLE%%", get_transient('quiz_title'.$session), $header);
				wp_mail($teachers_email, $header, $message);
			}
		}

		if($users_name=="UNKNOWN") $users_name="";
		if($users_email=="UNKNOWN") $users_email="";
		$wpdb->insert("ssquiz_users", 
			array('user_name'=>$users_name, 
			'user_email'=>$users_email, 
			'answered'=>get_transient('questions_counter'.$session), 
			'correct'=>get_transient('questions_right'.$session),
			'quiz'=>get_transient('quiz_title'.$session),
			'quiz_id'=>get_transient('quiz_id'.$session),
			'user_id'=>$current_user->ID,
			'total'=>get_transient('total_questions'.$session)));
		
		$lastid = $wpdb->insert_id;
		add_option("ssquiz_user_".$lastid, $file_name, "", "no");
		
		
		/*
		delete_transient('questions_right'.$session);
		delete_transient('total_questions'.$session);
		delete_transient('questions_counter'.$session);
		delete_transient('answer_sheet'.$session);
		*/
		delete_transient('quiz_title'.$session);
		delete_transient('quiz_id'.$session);
		delete_transient('quiz_title'.$session);
		delete_transient('quiz_description'.$session);
		delete_transient('quiz_next'.$session);

		
		die();
}

function create_pdf($session, $file_name)
{
	global $wpdb;
	$wpdb->show_errors(); 
	require_once("dompdf/dompdf_config.inc.php");
	
	$result = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='report_header' LIMIT 1");
	global $current_user;
	get_currentuserinfo();
	if(get_transient("name".$session))
		$users_name = get_transient("user_name".$session);
	else if(strlen($current_user->display_name)>3)
		$users_name = $current_user->display_name;
	else
		$users_name = "UNKNOWN";
	$result=str_replace("%%NAME%%", $users_name, $result);
	$result=str_replace("%%NUMBER%%", get_transient('quiz_id'.$session), $result);
	$result = stripslashes(html_entity_decode(tag_replace($result, $session)));

	$html = render_report($session);
	$dompdf = new DOMPDF();
	$dompdf->load_html('<html><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/><body style="padding:50px;">'.$result.$html.'</body></html>');
	$dompdf->render();
	$dir = wp_upload_dir();
	$dir = $dir["basedir"].DIRECTORY_SEPARATOR."exams";
	if (!is_dir($dir)) mkdir($dir);
	$file = $dir.DIRECTORY_SEPARATOR. $file_name . ".pdf";
	$output = $dompdf->output();
	file_put_contents($file, $output);
}

function render_report($session){
	global $wpdb;
	$wpdb->show_errors();

	$quiz_id = get_transient('quiz_id'.$session);
	$total = intval(get_transient('questions_counter'.$session));
	$temp=get_transient('answer_sheet'.$session);

	ob_start();

	for($number=1; $number<=$total; $number++)
	{
		$question = $wpdb->get_var("SELECT question FROM ssquiz_questions WHERE id=".intval($temp[$number]["question_id"]));
		$temp=get_transient('answer_sheet'.$session);
		
		$question = $wpdb->get_var("SELECT question FROM ssquiz_questions WHERE id=".intval($temp[$number]["question_id"]));
		$correct = $wpdb->get_col("SELECT answer FROM ssquiz_answers WHERE question_id='".intval($temp[$number]["question_id"])."' AND correct='1'");
		echo '<div style="margin: 10px 0 20px;">';
		echo '<div class="question"><strong>'.__("Question", 'ssquiz').' #'.$number.':</strong><br  />'; 
		
		$pattern = '/\[(\d+)\*(\d+)\]/i';
		$question = preg_replace($pattern, "", $question);
		
		echo stripslashes(stripslashes(html_entity_decode($question))); 
		echo '</div><br />';
		
		if($temp[$number]["correct"] !== 3)
			echo '<font color="green">'.__("Correct answer", 'ssquiz').': '.implode(" ", $correct). '</font><br/>';
		
		if($temp[$number]["correct"]==false){
			if(strlen($temp[$number]["answer"])>0 && $temp[$number]["answer"]!='NA')
				echo '<font color="red">'.__("User's answer", 'ssquiz').': '.$temp[$number]["answer"]. '</font>';
			else
				echo "<font color='red'>".__("User didn't answer to this question.", 'ssquiz')."</font>";
		}
		else if($temp[$number]["correct"]===3){
			if(strlen($temp[$number]["answer"])>0 && $temp[$number]["answer"]!='NA')
				echo '<font>'.__("User's answer", 'ssquiz').':</font> <pre>'.$temp[$number]["answer"]. '</pre>';
			else
				echo "<font color='red'>".__("User didn't answer to this question.", 'ssquiz')."</font>";
		}
		else if($temp[$number]["correct"]==true){
			echo '<font color="green">'.__("User's answer", 'ssquiz').': '.$temp[$number]["answer"]. '</font><br/>';
		}
		
		if(isset($temp[$number]["hint"]) && $temp[$number]["hint"]==true){
			echo '<br /><em>Hint was used.</em>';
		}
		echo '</div>';
		echo '<hr style="background-color: #E7E7E7; border: 0 none; height: 1px;"/>';
	}
	$output_string=ob_get_contents();
	ob_end_clean();
	return $output_string;
}

function draw_history($number, $session){
	global $wpdb;
	$wpdb->show_errors();
	
	$temp=get_transient('answer_sheet'.$session);
	
	$question = $wpdb->get_var("SELECT question FROM ssquiz_questions WHERE id=".intval($temp[$number]["question_id"]));
	$correct = $wpdb->get_col("SELECT answer FROM ssquiz_answers WHERE question_id='".intval($temp[$number]["question_id"])."' AND correct='1'");
	$test = explode("|", $correct[0]);
	if(count($test)>1)
		$correct = array($test[0]);
		
	echo '<div class="question"><strong>'.__("Question", 'ssquiz').' #'.$number.':</strong><br  />'; 
	
	$pattern = '/\[(\d+)\*(\d+)\]/i';
	$question = preg_replace($pattern, "", $question);
	$question = apply_filters('the_content', $question);
	echo stripslashes(stripslashes(html_entity_decode($question))); 
	echo '</div><br />';
	
	if($temp[$number]["correct"] !== 3)
		echo '<font color="green">'.__("Correct answer", 'ssquiz').': '.implode(" ", $correct). '</font><br/>';

	if($temp[$number]["correct"]==false){
		if(strlen($temp[$number]["answer"])>0 && $temp[$number]["answer"]!='NA')
			echo '<font color="red">'.__("Your answer", 'ssquiz').': '.$temp[$number]["answer"]. '</font>';
		else
			echo "<font color='red'>".__("You didn't answer to this question.", 'ssquiz')."</font>";
	}
	else if($temp[$number]["correct"]===3){
		if(strlen($temp[$number]["answer"])>0 && $temp[$number]["answer"]!='NA')
			echo '<font>'.__("Your answer", 'ssquiz').':<br />'.$temp[$number]["answer"]. '</font>';
		else
			echo "<font color='red'>".__("You didn't answer to this question.", 'ssquiz')."</font>";
	}
	else if($temp[$number]["correct"]==true)
		echo '<font color="green">'.__("You were right!", 'ssquiz').'</font>';
		
	if($temp[$number]["hint"]==true){
		echo '<br /><em>Hint was used.</em>';
	}
}

function view_answer() {
	$session=intval($_POST["session"]);
	$option=intval($_POST["option"]);

	if($option==-1)
		$number=get_transient("history_view".$session)-1;
	else if ($option==-2)
		$number=get_transient("history_view".$session)+1;
	else if ($option>0)
		$number=$option;
	 else
		die("Internal error 45");
	set_transient("history_view".$session, $number, 9999);
	draw_history($number, $session);
	echo '<br /><center>';
	if($number>1)
		echo '<a class="ssanswer_history prev"><<</a>';
	echo '<a class="ssback">'.__("Back", 'ssquiz').'</a>';
	if($number<get_transient('questions_counter'.$session))
		echo '<a class="ssanswer_history forw">>></a>';
	echo '</center>';
	die();
}

function do_all(){
		global $wpdb;
		$wpdb->show_errors();
		$session=intval($_POST["session"]);
		$temps=array();
		$answer_sheet=array();
		$counter=1;
		if($_POST["answers"]!=NULL && $_POST["answers"]!='NA'){
			foreach ($_POST["answers"] as $answer) {
				if(!isset($temps[$answer['name']])) $temps[$answer['name']]=array();
				array_push($temps[$answer['name']], esc_attr(stripslashes($answer['value'])));
			}
			foreach ($temps as $name=>$value) {
					$answer_sheet[$counter]["question_id"]=$name;
					$answer_sheet[$counter]["answer"]=implode("|", $value);
					$answer_sheet[$counter]["correct"]=false;
					$row = $wpdb->get_col("SELECT answer FROM ssquiz_answers WHERE question_id='". $name ."' AND correct='1'");

					$test = "";
					$ttemp = $row[0];
					if($ttemp != "")
						$test = explode("|", $ttemp);

					if(count($test)>1 && in_array(strtolower($value[0]), array_map('strtolower', $test))) {
						set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
						$answer_sheet[$counter]["correct"]=true;
					}
					else if(array_map('strtolower',$row)==array_map('strtolower',$value)){
					//if($row==$value){ //case sensitive
						set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
						$answer_sheet[$counter]["correct"]=true;
					}
					$counter++;
				}
		}
		set_transient('answer_sheet'.$session, $answer_sheet, 9999);
		exit_quiz($session);
		die();
}

function start_quiz(){
		$session=intval($_POST["session"]);
		$user_email=stripslashes(esc_attr(strip_tags($_POST["user_email"])));
		$user_name=stripslashes(esc_attr(strip_tags($_POST["user_name"])));
		set_transient('user_email'.$session, $user_email, 9999);
		set_transient('user_name'.$session, $user_name, 9999);
		echo 'TEST STARTED';
		die();
}

function all_questions($session){
		global $wpdb;
		$wpdb->show_errors();
		$questions = $wpdb->get_results("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number!=99999 ORDER BY number");
		set_transient('questions_counter'.$session, count($questions), 9999);
		$qconter=1;
		echo '<script>document.getElementById("exit_but").style.display="none";</script>';
		if ($questions== NULL){
			echo '<script>document.getElementById("next_button").style.display="none";</script>';
			die(__("There is no tests in quiz", 'ssquiz')." <strong>". get_transient('quiz_title'.$session)."</strong>");
		}
		if(get_transient('qrandom'.$session)=='true')
			shuffle($questions);

		foreach($questions as $question){
			$question=get_object_vars($question);
			$answers = $wpdb->get_results( "SELECT * FROM ssquiz_answers WHERE question_id=" . $question['id'] . " ORDER BY number");
			$correct = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_answers WHERE question_id='".$question['id']."' AND correct='1'");
			
			echo '<div class="question_body">';
			echo '<div class="question"><strong>'.__("Question", 'ssquiz').' #' . $qconter++ . ':</strong><br  />';
				
			$textarea_style = '';
			$pattern = '/\[(\d+)\*(\d+)\]/i';
			preg_match($pattern, $question["question"], $matches);
			if(count($matches)==3)
				$textarea_style = 'style="width:' . $matches[1] . 'px; height:' . $matches[2] . 'px;"';
			$question["question"] = preg_replace($pattern, "", $question["question"]);
				
			echo stripslashes(stripslashes(html_entity_decode($question['question']))); 
			//set_transient('questions_counter'.$session, get_transient('questions_counter'.$session)+1, 9999);
			echo '</div><br />';
        	//--------checking for multianswer test
			//essay
			if(count($answers) == 0) {
				echo '<textarea name="'.$question['id'].'" class="answer" ' . $textarea_style . '></textarea>';
				set_transient('answer'.$session, "", 9999);
			}
			else if(count($answers)>1) {
				if(get_transient('arandom'.$session)=='true') 
					shuffle($answers);
				set_transient('answer'.$session, "", 9999);
				foreach($answers as $answer) {
					$answer=get_object_vars($answer);
					if($correct>1)
						echo '<input type="checkbox" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					else
						echo '<input type = "radio" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					
					if($answer['correct']=='1')
						set_transient('answer'.$session, get_transient('answer'.$session)."|".$answer['answer'], 9999);
				}
				//dummy radio checked
				if($correct==1)
					echo '<input type="radio" checked name="'.$question['id'].'" class="answer" value="NA" style="display:none">';
			}
			else 
				echo '<input type="text" class="answer" name="'.$question['id'].'" value=""/>';

			echo '</div>';
			if($question!=end($questions))
				echo '<hr /><br />';
        }
		echo '<script>jQuery(document).ready(function($){$("#next_button").html("'.__("Finish", 'ssquiz').'");});</script>';
		die();
}

function ssget_hint()
{
	global $wpdb;
	$wpdb->show_errors();
	$session = intval($_POST["session"]);
	$question_id = get_transient('question_id'.$session);

	$hint = $wpdb->get_var("SELECT hint FROM ssquiz_questions WHERE id='".$question_id . "'");
	$hint = stripslashes($hint);
	//hint usage mark in history
	$sheet = get_transient('answer_sheet'.$session);
	$sheet[get_transient('questions_counter'.$session)+1]["hint"] = true;
	set_transient('answer_sheet'.$session, $sheet, 9999);
	
	echo '<div class="sshint_div">'. $hint . '</div>';
	die();
}

function next_question($last=false){
		global $wpdb;
		$wpdb->show_errors();
		$session=intval($_POST["session"]);

		if(get_transient('questions_counter'.$session)>=0){
			$temp_array=get_transient('answer_sheet'.$session);
			$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=false;
			$temp2=explode("|", esc_attr(stripslashes($_POST["answer"])));

			$test = "";
			$ttemp = get_transient('answer'.$session);
			if($ttemp != "")
				$test = explode("|", $ttemp[0]);
			$sscorrect_answer = implode(", ", $test);
			
			//essay?
			if(get_transient('answer'.$session) == "") { 
				if($_POST["answer"] != "NA") {
					set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
				}
				$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=3;
			}
			// I'm cat|I am cat
			else if(count($test)>1 && in_array(strtolower($temp2[0]), array_map('strtolower', $test))) {
				set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
				$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=true;
				$sscorrect = true;
			}
			else if(array_map('strtolower', get_transient('answer'.$session))==array_map('strtolower', $temp2)){
			//if(get_transient('answer'.$session)==$temp2){ // case sensitive
				set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
				$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=true;
				$sscorrect = true;
			}
			$temp_array[get_transient('questions_counter'.$session)+1]["question_id"]=get_transient('question_id'.$session);
			$temp_array[get_transient('questions_counter'.$session)+1]["answer"]=esc_attr(stripslashes($_POST["answer"]));
			set_transient('answer_sheet'.$session, $temp_array, 9999);
			
			if ($sscorrect)
				$sstemp = "<font color='green'> Great - you were right!</font>";
			else
				$sstemp = "<font color='red'> Uh Oh! That's not it, mate! The answer to this is $sscorrect_answer</font>";
			echo "<div class='ssresult'>$sstemp</div>";
			
			if(get_transient('questions_counter'.$session)==get_transient('total_questions'.$session)-2) {
					echo '<script>jQuery(document).ready(function($){$("#next_button").html("'.__("Finish", 'ssquiz').'"); $("#exit_but").hide();});</script>';
				}
		}
		else
		{
			// first time function called?
			echo '<script>jQuery(document).ready(function($){$("#next_button").html("'.__("Next", 'ssquiz').'"); $("#exit_but").show();});</script>';
		}

		set_transient('questions_counter'.$session, get_transient('questions_counter'.$session)+1, 9999);
		if(get_transient('questions_counter'.$session)>get_transient('total_questions'.$session)-1 || $last) {
			exit_quiz($session, true);
		} else if (get_transient('all_questions'.$session)=="true") {
			all_questions($session);
			return;
		} else {
			if(get_transient('qrandom'.$session)) {
				if(!get_transient('qr'.$session)) {
					$random=range(1, get_transient('total_questions'.$session));
					shuffle($random);
					set_transient('qr'.$session, $random, 9999);
				} else {
					$random=get_transient('qr'.$session);
				}
				$question = $wpdb->get_row("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number='". $random[get_transient('questions_counter'.$session)] . "'", ARRAY_A);
			} else
				$question = $wpdb->get_row("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number='". (get_transient('questions_counter'.$session)+1) . "'", ARRAY_A);
		$answers = $wpdb->get_results("SELECT * FROM ssquiz_answers WHERE question_id='".$question['id']."' ORDER BY number");
		$correct = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_answers WHERE question_id='".$question['id']."' AND correct='1'");

		if ($question== NULL) {
			echo '<script>document.getElementById("next_button").style.display="none";document.getElementById("exit_but").style.display="none";</script>';
			die(__("There is no tests in quiz", 'ssquiz')." <strong>". get_transient('quiz_title'.$session)."</strong>");
		}

		// The last question?
		if(get_transient('show_correct'.$session) == false)
		{
			if(get_transient('questions_counter'.$session)==get_transient('total_questions'.$session)-1) {
				echo '<script>jQuery(document).ready(function($){$("#next_button").html("'.__("Finish", 'ssquiz').'"); $("#exit_but").hide();});</script>';
			}
		}

		set_transient('question_id'.$session, $question["id"], 9999); 
		//set_transient('answer'.$session, $answer, 9999);

		echo '<div class="question"><strong>'.__("Question", 'ssquiz').' #';
		echo get_transient('questions_counter'.$session)+1; echo ' of '. get_transient('total_questions'.$session).':</strong><br  />'; 
		
		$textarea_style = '';
		$pattern = '/\[(\d+)\*(\d+)\]/i';
		preg_match($pattern, $question["question"], $matches);
		
		if(count($matches)==3)
			$textarea_style = 'style="width:' . $matches[1] . 'px; height:' . $matches[2] . 'px;"';
			
		$question["question"] = preg_replace($pattern, "", $question["question"]);
		$question["question"] = apply_filters('the_content', $question["question"]);
		echo stripslashes(stripslashes(html_entity_decode($question["question"]))); 
		//echo '<br  />';
		$temp=array();
		
        //--------checking for multianswer test
		//$myrows = $wpdb->get_col( "SELECT answer FROM ssquiz_answers WHERE question_id=" .  $question["id"] . "ORDER BY number");
		
		//essay
		if(count($answers) == 0) {
			echo '<textarea class="answer" ' . $textarea_style . '></textarea>';
			set_transient('answer'.$session, "", 9999);
			set_transient('essay'.$session, "true", 9999);
		}
		else if(count($answers)>1) {
			//array_push($myrows, $question["answer"]);
			if(get_transient("arandom".$session)) 
				shuffle($answers);
			set_transient('answer'.$session, "", 9999);
			foreach($answers as $answer) {
				$answer=get_object_vars($answer);
				if($correct>1)
					echo '<input type="checkbox" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
				else
					echo '<input type = "radio" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					
				if($answer['correct']=='1')
					array_push($temp, $answer['answer']);
			}
			set_transient('answer'.$session, $temp, 9999);
		}
		else {
			echo '<input type = "text" class="answer" value="" id="answer_input" />';
			$answers=get_object_vars($answers[0]);
			array_push($temp, $answers['answer']);
			set_transient('answer'.$session, $temp, 9999);
		}
		$hint = $wpdb->get_var("SELECT hint FROM ssquiz_questions WHERE id='".$question['id']."'");
		if($hint != "")
			echo '<br /><input type="submit" class="sshint" value="Hint"/>';
		echo '</div>';
    }
	die();
}
add_action('wp_ajax_view_answer', 'view_answer');
add_action('wp_ajax_nopriv_view_answer', 'view_answer');
add_action('wp_ajax_exit_quiz', 'exit_quiz');
add_action('wp_ajax_nopriv_exit_quiz', 'exit_quiz');
add_action('wp_ajax_do_all', 'do_all');
add_action('wp_ajax_nopriv_do_all', 'do_all');
add_action('wp_ajax_start_quiz', 'start_quiz');
add_action('wp_ajax_nopriv_start_quiz', 'start_quiz');
add_action('wp_ajax_quiz_a', 'next_question');
add_action('wp_ajax_nopriv_quiz_a', 'next_question');

add_action('wp_ajax_ssget_hint', 'ssget_hint');
add_action('wp_ajax_nopriv_ssget_hint', 'ssget_hint');
