window.onload = function () {
    var r = Raphael("holder", 150, 100),
    	r2 = Raphael("holder2", 150, 100),
    	r3 = Raphael("holder3", 150, 100),
        R = 40,
        param = {stroke: "#eee", "stroke-width": 18},
        hash = document.location.hash,
        marksAttr = {fill: hash || "#444", stroke: "none"}

    // Custom Attribute
    r.customAttributes.arc = function (value, total, R) {
        var alpha = 360 / total * value,
            a = (90 - alpha) * Math.PI / 180,
            x = 75 + R * Math.cos(a),
            y = 50 - R * Math.sin(a),
            //color
            color = "hsb(".concat(".3, 0.7 , 1)"),
            path;
        //console.log(color);
        if (total == value) {
            path = [["M", 75, 50 - R], ["A", R, R, 0, 1, 1, 74.99, 50 - R]];
        } else {
            path = [["M", 75, 50 - R], ["A", R, R, 0, +(alpha > 180), 1, x, y]];
        }
        return {path: path, stroke: color};
    };
    
    var bg = r.path().attr({arc: [12, 12, R]}).attr(param);
    var mon = r.path().attr(param).attr({arc: [0, 12, R]});
    var t = r.text(75, 50, percent+"%");
	t.attr({"font-size": 25});
//-------

    // Custom Attribute
    r2.customAttributes.arc = function (value, total, R) {
        var alpha = 360 / total * value,
            a = (90 - alpha) * Math.PI / 180,
            x = 75 + R * Math.cos(a),
            y = 50 - R * Math.sin(a),
            //color
            color = "hsb(.1, 0.7, 1)",
            path;
        if (total == value) {
            path = [["M", 75, 50 - R], ["A", R, R, 0, 1, 1, 74.99, 50 - R]];
        } else {
            path = [["M", 75, 50 - R], ["A", R, R, 0, +(alpha > 180), 1, x, y]];
        }
        return {path: path, stroke: color};
    };

    var bg2 = r2.path().attr({arc: [12, 12, R]}).attr(param);
    var days = r2.path().attr(param).attr({arc: [0, 12, R]});
    var t2 = r2.text(75, 50, percent2);
	t2.attr({"font-size": 25});
	
	var c = r3.rect(35, 10, 80, 80);
	c.attr(param);
    var t3 = r3.text(75, 50, percent3);
	t3.attr({"font-size": 25});

    (function () {
    	total = 100;
    	value = percent;
    	hand = mon;
    	
        var color = "hsb(".concat(Math.round(R) / 200, ",", value / total, ", .75)");
        hand.animate({arc: [value, total, R]}, 900, ">");
        //---
        
        total = total_quizzes;
    	value = percent2;
    	hand = days;
    	
        var color = "hsb(".concat(Math.round(R) / 200, ",", value / total, ", .75)");
        hand.animate({arc: [value, total, R]}, 900, ">");
    })();
};